// локальный контроллер
// радиальный интерфейс UART

#include <MsTimer2.h>
#include <OneWire.h>
#include <Button.h>

OneWire sensTmp (3); // датчик подключен к выводу 3
Button button1(2, 30); // кнопка подключена к выводу 2

float temperature; // температура
float voltage; // напряжение
byte bufSensTmp[9]; // буфер данных датчика температуры
int timeCount; // счетчик времени

void setup() {
MsTimer2::set(1, timerInterrupt); // прерывания по таймеру 1 мс 
MsTimer2::start(); // разрешаем прерывание по таймеру
Serial.begin(9600); // скорость 9600 
}

void loop() {
//------------------------------- измерение температуры
if (timeCount < 50) {
timeCount= 50;
sensTmp.reset(); // сброс шины
sensTmp.write(0xCC, 1); // пропуск ROM
sensTmp.write(0x44, 1); // инициализация измерения 
}
// задержка 0,9 сек
if(timeCount > 950) {
timeCount= 0; 
sensTmp.reset(); // сброс шины
sensTmp.write(0xCC, 1); // пропуск ROM 
sensTmp.write(0xBE, 1); // команда чтения памяти датчика 
sensTmp.read_bytes(bufSensTmp, 9); // чтение памяти датчика, 9 байтов
if ( OneWire::crc8(bufSensTmp, 8) == bufSensTmp[8] ) { // проверка CRC
// данные правильные
temperature= (float)((int)bufSensTmp[0] | (((int)bufSensTmp[1]) << 8)) * 0.0625 + 0.03125; 
}
else temperature= -200.; // ошибка измерения температуры 
}

//------------------------------- измерение напряжения
voltage= (float)(analogRead(A0)) * 5. / 1024.;

//----------------------------- проверка измерений
Serial.print("T= ");
Serial.print(temperature);
Serial.print(" U= ");
Serial.print(voltage);
if (button1.flagPress == true) Serial.println(" PRESS");
else Serial.println(" FREE");

delay(1000);
}

//-------------------------------------- обработчик прерывания 1 мс
void timerInterrupt() {
timeCount++;
button1.scanState(); // вызов метода обработки состояния кнопки 
}
